package com.mh.user.annotation;

import java.lang.annotation.*;

/**
 * @author LJF
 * @version 1.0
 * @project mh_esi
 * @description 数据字典注解
 * @date 2024-11-08 11:40:46
 */
@Target(ElementType.FIELD)
@Inherited
@Retention(RetentionPolicy.RUNTIME)
@Documented
public @interface FieldParam {

    /**
     * 字典值
     * @return
     */
    String value() default "";

    /**
     * 字典类型
     * @return
     */
    String type() default "";

    /**
     * 字典标签
     * @return
     */
    String label() default "";

    /**
     * 要翻译的字段，目标字段翻译的字段+Str
     * @return
     */
    String targetField() default "";

    /**
     * 要翻译的字段值类型
     * @return
     */
    Class targetFieldValueClazz() default String.class;

}
