package com.mh.user.constants;

import com.mh.user.factory.CJ188Protocol;
import com.mh.user.factory.EleProtocol;
import com.mh.user.factory.ModbusProtocol;
import com.mh.user.factory.Protocol;

/**
 * @author LJF
 * @version 1.0
 * @project mh_esi
 * @description 协议枚举类
 * @date 2024-09-12 10:31:53
 */
public enum ProtocolEnum {

    CJ188_PROTOCOL("0", CJ188Protocol.getInstance()),

    MODBUS_PROTOCOL("1", ModbusProtocol.getInstance()),

    ELE_97_PROTOCOL("2", EleProtocol.getInstance()),

    ELE_07_PROTOCOL("3", EleProtocol.getInstance()),

    ;

    private String protocolType;

    private Protocol protocol;

    private ProtocolEnum(String protocolType, Protocol protocol) {
        this.protocolType = protocolType;
        this.protocol = protocol;
    }

    public String getProtocolType() {
        return protocolType;
    }

    public void setProtocolType(String protocolType) {
        this.protocolType = protocolType;
    }

    public Protocol getProtocol() {
        return protocol;
    }

    public void setProtocol(Protocol protocol) {
        this.protocol = protocol;
    }

    public static Protocol getProtocol(String protocolType) {
        for (ProtocolEnum protocolEnum : ProtocolEnum.values()) {
            if (protocolEnum.getProtocolType().equals(protocolType)) {
                return protocolEnum.getProtocol();
            }
        }
        return null;
    }
}
