package com.mh.user.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author LJF
 * @version 1.0
 * @project mh_esi
 * @description 仪表管理
 * @date 2024-08-22 16:35:19
 */
@Setter
@Getter
@TableName("meter_manage")
public class MeterManageEntity implements Serializable {

    /**
     * 编号
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 仪表类型
     */
    private Long mtType;

    /**
     * 仪表名称
     */
    private String mtName;

    /**
     * 其他名称
     */
    private String otherName;

    /**
     * 仪表品牌
     */
    private String mtBrand;

    /**
     * 仪表编号
     */
    private String mtNum;

    /**
     * 仪表地址
     */
    private String mtCode;

    /**
     * 寄存器地址
     */
    private String registerAddr;

    /**
     * 功能码
     */
    private String funcCode;

    /**
     * 数据标识码
     */
    private String identifyCode;

    /**
     * 口径以及脉冲常数
     */
    private String mtCaliberPulse;

    /**
     * 仪表范围
     */
    private BigDecimal mtRange;

    /**
     * 仪表比例
     */
    private int mtRatio;

    /**
     * 初始值
     */
    private BigDecimal mtInitValue;

    /**
     * 保留位数
     */
    private int digits;

    /**
     * 数据类型
     */
    private int dataType;

    /**
     * 当前值
     */
    private BigDecimal curValue;

    /**
     * 当前时间
     */
    private Date curTime;

    /**
     * 是否是总表
     */
    private byte mtIsSum;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新时间
     */
    private Date updateTime;

    /**
     * 单位
     */
    private String unit;

    /**
     * 排序
     */
    private Long sort;

    /**
     * 通讯串口
     */
    private String dataCom;

    /**
     * 设备id
     */
    private Long deviceId;

    /**
     * 网关id
     */
    private Long gatewayId;

    /**
     * 参数id
     */
    private Long paramId;

    /**
     * 协议类型
     */
    private int protocolType;

    /**
     * 备注
     */
    private String remark;

    /**
     * 保留位
     */
    private Integer grade = 0;

    /**
     * 系统类型id
     */
    private Long systemId;

    /**
     * 项目id
     */
    private Long projectId;

    /**
     * 通讯类型
     */
    private Long communicationType;

    /**
     * 读取寄存器大小
     */
    private int registerSize;

    /**
     * 采集点是否启用
     */
    private String isUse;

    @Override
    public String toString() {
        return "MeterManageEntity{" +
                "id=" + id +
                ", mtType=" + mtType +
                ", mtName='" + mtName + '\'' +
                ", otherName='" + otherName + '\'' +
                ", mtBrand='" + mtBrand + '\'' +
                ", mtNum='" + mtNum + '\'' +
                ", mtCode='" + mtCode + '\'' +
                ", registerAddr='" + registerAddr + '\'' +
                ", funcCode='" + funcCode + '\'' +
                ", identifyCode='" + identifyCode + '\'' +
                ", mtCaliberPulse='" + mtCaliberPulse + '\'' +
                ", mtRange=" + mtRange +
                ", mtRatio=" + mtRatio +
                ", mtInitValue=" + mtInitValue +
                ", digits=" + digits +
                ", dataType=" + dataType +
                ", curValue=" + curValue +
                ", curTime=" + curTime +
                ", mtIsSum=" + mtIsSum +
                ", createTime=" + createTime +
                ", updateTime=" + updateTime +
                ", unit='" + unit + '\'' +
                ", sort=" + sort +
                ", dataCom='" + dataCom + '\'' +
                ", deviceId=" + deviceId +
                ", gatewayId=" + gatewayId +
                ", paramId=" + paramId +
                ", protocolType=" + protocolType +
                ", remark='" + remark + '\'' +
                ", grade=" + grade +
                ", systemId=" + systemId +
                ", projectId=" + projectId +
                ", communicationType=" + communicationType +
                ", registerSize=" + registerSize +
                ", isUse=" + isUse +
                '}';
    }
}
