package com.mh.user.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.mh.user.entity.DataResultChEntity;
import com.mh.user.entity.DataResultClEntity;
import org.apache.ibatis.annotations.*;

import java.util.List;

/**
 * @author LJF
 * @version 1.0
 * @project mh_esi
 * @description 数据冷量计
 * @date 2024-07-10 15:20:55
 */
@Mapper
public interface DataResultClMapper extends BaseMapper<DataResultClEntity> {
    //----------------------------------------------------------------------------------------------
    //保存冷量计数据
    @Insert("insert into data_result_cl(device_addr,device_type,project_id,last_value,last_date,cur_value,cur_date,ratio,calc_value,grade,register_addr,register_name) values (" +
            " #{deviceAddr},#{deviceType},#{projectId},#{lastValue},#{lastDate},#{curValue},#{curDate},#{ratio},#{calcValue},#{grade},#{registerAddr},#{registerName})")
    void saveDataResultCl(DataResultClEntity dataResultClEntity);

    @Update("<script>" +
            "  update data_result_cl set  " +
            "  <if test='deviceAddr!=null'>  device_addr = #{deviceAddr} </if>" +
            "  <if test='deviceType!=null'> , device_type = #{deviceType} </if>" +
            "  <if test='projectId!=null'> , project_id = #{projectId} </if>" +
            "  <if test='lastValue!=null'> , last_value = #{lastValue} </if>" +
            "  <if test='lastDate!=null'> , last_date = #{lastDate} </if>" +
            "  <if test='curValue!=null'> , cur_value = #{curValue} </if>" +
            "  <if test='ratio!=null'> , ratio = #{ratio} </if>" +
            "  <if test='calcValue!=null'> , calc_value = #{calcValue} </if>" +
            "  <if test='grade!=null'> , grade = #{grade} </if>" +
            "  <if test='registerAddr!=null'> , register_addr = #{registerAddr} </if>" +
            "  <if test='registerName!=null'> , register_name = #{registerName} </if>" +
            "   where cur_date=#{curDate} and device_addr=#{deviceAddr} and device_type=#{deviceType}" +
            "</script>")
    void updateDataResultCl(DataResultClEntity dataResultClEntity);

}
