package com.mh.user.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.mh.user.entity.DeviceCodeEntity;
import com.mh.user.model.ChillerModel;
import com.mh.user.model.DeviceModel;
import org.apache.ibatis.annotations.*;

import java.util.List;

/**
 * @author LJF
 * @version 1.0
 * @project mh_esi
 * @description 设备参数mapper
 * @date 2024-07-11 15:37:48
 */
@Mapper
public interface DeviceCodeMapper extends BaseMapper<DeviceCodeEntity> {

    //查询冷水机设备列表
    @Results({
            @Result(column = "device_addr",property = "deviceAddr" ),
            @Result(column = "device_name", property = "deviceName")
    })
    @Select("select * from  device_code  where  project_id=#{projectId}  and  device_type='冷水机'")
    List<DeviceModel> selectDevices(@Param("projectId") String projectId);


    //查询多个冷水机相关信息
    @Results({
            @Result(column = "device_addr",property = "deviceAddr" ),
            @Result(column = "device_name", property = "deviceName"),
            @Result(column = "run_State", property = "runState"),
            @Result(column = "set_Point", property = "setPoint"),
            @Result(column = "enter_chw", property = "enterChw"),
            @Result(column = "leave_chw", property = "leaveChw"),
            @Result(column = "enter_cow", property = "enterCow"),
            @Result(column = "leave_cow", property = "leaveCow"),
            @Result(column = "power", property = "power"),
            @Result(column = "rated_power", property = "ratedPower"),
            @Result(column = "chiller_amps", property = "chillerAmps"),
            @Result(column = "refrigeration", property = "refrigeration"),
            @Result(column = "rated_ref", property = "ratedRef"),
            @Result(column = "chw_flow", property = "chwFlow"),
            @Result(column = "approach_cow", property = "ApproachCow"),
            @Result(column = "approach_chw", property = "ApproachChw"),
            @Result(column = "cop", property = "cop"),
            @Result(column = "rated_cop", property = "ratedCop"),
            @Result(column = "copy_date", property = "copyDate")
    })
    @Select("select * from  device_code  where project_id=#{projectId}  and  device_addr=#{deviceAddr} ")
    List<ChillerModel> queryChiller(@Param("projectId") String projectId, @Param("device_addr") String deviceAddr);

}
