package com.mh.user.mapper;

import com.mh.user.entity.DeviceInfoEntity;
import com.mh.user.mapper.provider.DeviceInfoProvider;
import com.mh.user.model.ChillerModel;
import com.mh.user.model.DeviceModel;
import org.apache.ibatis.annotations.*;

import java.util.List;

@Mapper
public interface DeviceInfoMapper {

    //查询仪表信息
    @SelectProvider(type = DeviceInfoProvider.class,method = "queryDeviceInfo")
    @Results(value = {
            @Result(property="id",column="id"),
            @Result(property="deviceName",column="device_name"),
            @Result(property="deviceType",column="device_type"),
            @Result(property="brand",column="brand"),
            @Result(property ="power",column ="power"),
            @Result(property ="madeTime",column ="made_time"),
            @Result(property="flow",column="flow"),
            @Result(property="isFc",column="is_fc"),
            @Result(property="motorBrand",column="motor_brand"),
            @Result(property="projectId",column="project_id"),
            @Result(property="systemId",column="system_id"),
            @Result(property="cop",column="cop")
    })
    List<DeviceInfoEntity> queryDeviceInfo(@Param("systemID") String systemID,
                                           @Param("projectId") String projectId,
                                           @Param("deviceType") String deviceType);

    //查询单个冷水机相关信息
    @Results({
            @Result(column = "device_addr",property = "deviceAddr" ),
            @Result(column = "device_name", property = "deviceName"),
            @Result(column = "run_state", property = "runState"),
            @Result(column = "set_point", property = "setPoint"),
            @Result(column = "enter_chw", property = "enterChw"),
            @Result(column = "leave_chw", property = "leaveChw"),
            @Result(column = "enter_cow", property = "enterCow"),
            @Result(column = "leave_cow", property = "leaveCow"),
            @Result(column = "power", property = "power"),
            @Result(column = "rated_power", property = "ratedPower"),
            @Result(column = "chiller_amps", property = "chillerAmps"),
            @Result(column = "refrigeration", property = "refrigeration"),
            @Result(column = "rated_ref", property = "ratedRef"),
            @Result(column = "chw_flow", property = "chwFlow"),
            @Result(column = "approach_cow", property = "ApproachCow"),
            @Result(column = "approach_chw", property = "ApproachChw"),
            @Result(column = "cop", property = "cop"),
            @Result(column = "rated_cop", property = "ratedCop"),
            @Result(column = "copy_date", property = "copyDate")
    })
    @Select("select * from  chiller_data  where  project_id=#{projectId}  and  device_addr=#{deviceAddr} ")
    ChillerModel selectChiller(@Param("projectId") String projectId,@Param("device_addr") String deviceAddr);
}
