package com.mh.user.mapper.provider;

import org.apache.ibatis.annotations.Param;

import java.util.Map;

public class EnergyDataProvider {

    //按十分钟
    public String queryEnergyDataMi(String projectId, String curDate, int page, int limit) {
        StringBuffer sql = new StringBuffer("");
        sql.append("select T.*,t2.*,T1.project_name from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_mi  " +
                " where 1=1 ");
        if (projectId != null && !projectId.equals("")) {
            sql.append(" AND project_id = #{projectId} ");
        } else {
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
        }
        if (projectId.equals("所有")) {
            if ((page != 0) && (limit != 0)) {
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date ");
            } else if (page == 0) {
                sql.append(" )T order by T.cur_date ");
            }
        } else {
            if ((page != 0) && (limit != 0)) {
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date ");
            } else if (page == 0) {
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  order by T.cur_date ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //记录数
    public String getEnergyDataMiCount(String projectId, String curDate) {
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_mi  " +
                " where 1=1 ");
        if (projectId != null && !projectId.equals("")) {
            sql.append(" AND project_id = #{projectId} ");
        } else {
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
        }
        if (projectId.equals("所有")) {
            sql.append(" )T ");
        } else {
            sql.append(" )T join project_info T1  ON T.project_id=T1.id ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //按小时
    public String queryEnergyDataHour(String projectId, String curDate, int page, int limit) {
        StringBuffer sql = new StringBuffer("");
        sql.append("select T.*,t2.*,T1.project_name from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_hour  " +
                " where 1=1 ");
        if (projectId != null && !projectId.equals("")) {
            sql.append(" AND project_id = #{projectId} ");
        } else {
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
        }
        assert projectId != null;
        if (projectId.equals("所有")) {
            if ((page != 0) && (limit != 0)) {
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date ");
            } else if (page == 0) {
                sql.append(" )T order by T.cur_date ");
            }
        } else {
            if ((page != 0) && (limit != 0)) {
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  join hour_temperature t2  on LEFT(T.cur_date,13)=CONVERT(VARCHAR(13),t2.cur_date,121) where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date ");
            } else if (page == 0) {
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  join hour_temperature t2  on LEFT(T.cur_date,13)=CONVERT(VARCHAR(13),t2.cur_date,121) order by T.cur_date ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //按小时记录数
    public String getEnergyDataHourCount(String projectId, String curDate) {
        StringBuffer sql = new StringBuffer("");

        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_hour  " +
                " where 1=1 ");
        if (projectId != null && !projectId.equals("")) {
            sql.append(" AND project_id = #{projectId} ");
        } else {
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
        }
        if (projectId.equals("所有")) {
            sql.append(" )T ");
        } else {
            sql.append(" )T join project_info T1  ON T.project_id=T1.id  join hour_temperature t2  on LEFT(T.cur_date,13)=CONVERT(VARCHAR(13),t2.cur_date,121)");
        }

        System.out.println(sql.toString());
        return sql.toString();
    }

    //按天
    public String queryEnergyDataDay(String projectId, String curDate, int queryType, int page, int limit) {
        StringBuffer sql = new StringBuffer("");
        sql.append("select T.*,t2.*,T1.project_name from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_day  " +
                " where 1=1 ");
        if (projectId != null && !projectId.equals("")) {
            sql.append(" AND project_id = #{projectId} ");
        } else {
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            if (queryType == 0) {
                sql.append(" AND LEFT(cur_date,7)=#{curDate} ");
            } else {
                sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
            }
        }
        if (projectId.equals("所有")) {
            if ((page != 0) && (limit != 0)) {
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date ");
            } else if (page == 0) {
                sql.append(" )T order by T.cur_date  ");
            }
        } else {
            if ((page != 0) && (limit != 0)) {
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  join date_temperature t2  on LEFT(T.cur_date,10)=CONVERT(VARCHAR(10),t2.cur_date,121) where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date ");
            } else if (page == 0) {
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  join date_temperature t2  on LEFT(T.cur_date,10)=CONVERT(VARCHAR(10),t2.cur_date,121) order by T.cur_date  ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //记录数
    public String getEnergyDataDayCount(String projectId, String curDate, int queryType) {
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_day  " +
                " where 1=1 ");
        if (projectId != null && !projectId.equals("")) {
            sql.append(" AND project_id = #{projectId} ");
        } else {
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            if (queryType == 0) {
                sql.append(" AND LEFT(cur_date,7)=#{curDate} ");
            } else {
                sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
            }
        }
        if (projectId.equals("所有")) {
            sql.append(" )T ");
        } else {
            sql.append(" )T join project_info T1  ON T.project_id=T1.id  join date_temperature t2  on LEFT(T.cur_date,10)=CONVERT(VARCHAR(10),t2.cur_date,121) ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //按月
    public String queryEnergyDataMonth(String projectId, String curDate, int queryType, int page, int limit) {
        StringBuffer sql = new StringBuffer("");
        sql.append("select T.*,T1.project_name from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_month  " +
                " where 1=1 ");
        if (projectId != null && !projectId.equals("")) {
            sql.append(" AND project_id = #{projectId} ");
        } else {
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            if (queryType == 0) {
                sql.append(" AND LEFT(cur_date,4)=#{curDate} ");
            } else {
                sql.append(" AND LEFT(cur_date,7)=#{curDate} ");
            }
        }
        if (projectId.equals("所有")) {
            if ((page != 0) && (limit != 0)) {
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date ");
            } else if (page == 0) {
                sql.append(" )T order by T.cur_date  ");
            }
        } else {
            if ((page != 0) && (limit != 0)) {
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date  ");
            } else if (page == 0) {
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  order by T.cur_date  ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //记录数
    public String getEnergyDataMonthCount(String projectId, String curDate, int queryType) {
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_month  " +
                " where 1=1 ");
        if (projectId != null && !projectId.equals("")) {
            sql.append(" AND project_id = #{projectId} ");
        } else {
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            if (queryType == 0) {
                sql.append(" AND LEFT(cur_date,4)=#{curDate} ");
            } else {
                sql.append(" AND LEFT(cur_date,7)=#{curDate} ");
            }
        }
        if (projectId.equals("所有")) {
            sql.append(" )T ");
        } else {
            sql.append(" )T join project_info T1  ON T.project_id=T1.id ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    public String queryEnergyDataYear(String projectId, String startDate, String endDate, int queryType, int page, int limit) {
        StringBuffer sql = new StringBuffer("");
        sql.append("select T.*,T1.project_name from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_year  " +
                " where 1=1 ");
        if (projectId != null && !projectId.equals("")) {
            sql.append(" AND project_id = #{projectId} ");
        } else {
            sql.append(" AND project_id <>'所有' ");
        }
        if (queryType == 0) {
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)>=#{startDate} ");
            }
            if (endDate != null && !endDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)<=#{endDate} ");
            }
        } else {
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)=#{startDate} ");
            }
        }
        if (projectId.equals("所有")) {
            if ((page != 0) && (limit != 0)) {
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date  ");
            } else if (page == 0) {
                sql.append(" )T  order by T.cur_date  ");
            }
        } else {
            if ((page != 0) && (limit != 0)) {
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date  ");
            } else if (page == 0) {
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  order by T.cur_date  ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //记录数
    public String getEnergyDataYearCount(String projectId, String startDate, String endDate, int queryType) {
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_year  " +
                " where 1=1 ");
        if (projectId != null && !projectId.equals("")) {
            sql.append(" AND project_id = #{projectId} ");
        } else {
            sql.append(" AND project_id <>'所有' ");
        }
        if (queryType == 0) {
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)>=#{startDate} ");
            }
            if (endDate != null && !endDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)<=#{endDate} ");
            }
        } else {
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)=#{startDate} ");
            }
        }
        if (projectId.equals("所有")) {
            sql.append(" )T ");
        } else {
            sql.append(" )T join project_info T1  ON T.project_id=T1.id ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    public String queryMomEnergyHourAndDayData(Map<String, Object> params) {
        StringBuilder sql = new StringBuilder();
        sql.append("select " +
                "  t1.cur_date, " +
                "  t1.elect, " +
                "  t1.cl, " +
                "  t1.cop, " +
                "  t1.project_id, " +
                "  pi2.project_name, " +
                "  t2.elect as last_elect, " +
                "  t2.cl as last_cl, " +
                "  t2.cop as last_cop, " +
                "  case " +
                "   when t2.elect > 0 then concat(convert(decimal(18, 2),(t1.elect - t2.elect)/ t2.elect * 100), '%') " +
                "   else '上期无数据' " +
                "  end elect_ratio, " +
                "  case " +
                "   when t2.cl > 0 then concat(convert(decimal(18, 2),(t1.cl - t2.cl)/ t2.cl * 100), '%') " +
                "   else '上期无数据' " +
                "  end cl_ratio, " +
                "  case " +
                "   when t2.cop > 0 then concat(convert(decimal(18, 2),(t1.cop - t2.cop)/ t2.cop * 100), '%') " +
                "   else '上期无数据' " +
                "  end cop_ratio, " +
                "  ht.amb_temp, " +
                "  ht.humidity " +
                "from " +
                " ( " +
                "  select " +
                "   cur_date, " +
                "   elect, " +
                "   cl, " +
                "   cop, " +
                "   project_id, " +
                "   convert(datetime, ");
        concatMomSql(params, sql);
        sql.append(
                "  from " +
                        "   ${tableName} " +
                        "  where " +
                        "   cur_date >= #{startDate} " +
                        "   and cur_date <= #{endDate} " +
                        "   and project_id = #{projectId} " +
                        "    ) t1 " +
                        "left join " +
                        "    ( " +
                        "  select " +
                        "   cur_date, " +
                        "   elect, " +
                        "   cl, " +
                        "   cop, " +
                        "   project_id, " +
                        "   convert(datetime, ");
        concatMomSql(params, sql);
        sql.append(
                "  from " +
                        "   ${tableName} " +
                        "  where " +
                        "   cur_date >= #{lastStartDate} " +
                        "   and cur_date <= #{lastEndDate} " +
                        "   and project_id = #{projectId} " +
                        "    ) t2 " +
                        "    on " +
                        "  t1.change_cur_date = dateadd(${dateType}, 1, t2.change_cur_date) " +
                        "left join hour_temperature ht  " +
                        "on " +
                        "  ht.cur_date = t1.change_cur_date " +
                        "left join ( " +
                        "  select " +
                        "   id, " +
                        "   project_name " +
                        "  from " +
                        "   project_info " +
                        "  where " +
                        "   id = #{projectId}) pi2  " +
                        "on " +
                        "  pi2.id = t1.project_id " +
                        "order by " +
                        "  t1.cur_date ");
        return sql.toString();
    }

    private static void concatMomSql(Map<String, Object> params, StringBuilder sql) {
        if ("year".equals(params.get("dateType"))) {
            sql.append("   concat(cur_date, '-01-01 00:00:00')) as change_cur_date ");
        } else if ("month".equals(params.get("dateType"))) {
            sql.append("   concat(cur_date, '-01 00:00:00')) as change_cur_date ");
        } else if ("day".equals(params.get("dateType"))) {
            sql.append("   concat(cur_date, ' 00:00:00')) as change_cur_date ");
        } else if ("hour".equals(params.get("dateType"))) {
            sql.append("   concat(cur_date, ':00:00')) as change_cur_date ");
        }
    }

    public String queryYoyEnergyHourAndDayData(Map<String, Object> params) {
        StringBuilder sql = new StringBuilder();
        sql.append("select " +
                "    t1.cur_date, " +
                "    t1.elect, " +
                "    t1.cl, " +
                "    t1.cop, " +
                "    t1.project_id, " +
                "    pi2.project_name, " +
                "    t2.elect as last_elect, " +
                "    t2.cl as last_cl, " +
                "    t2.cop as last_cop, " +
                "    case " +
                "        when t2.elect > 0 then concat(convert(decimal(18, 2),(t1.elect - t2.elect)/ t2.elect * 100), '%') " +
                "        when t2.elect = 0 then '0' " +
                "        else '上期无数据' " +
                "        end elect_ratio, " +
                "    case " +
                "        when t2.cl > 0 then concat(convert(decimal(18, 2),(t1.cl - t2.cl)/ t2.cl * 100), '%') " +
                "        when t2.cl = 0 then '0' " +
                "        else '上期无数据' " +
                "        end cl_ratio, " +
                "    case " +
                "        when t2.cop > 0 then concat(convert(decimal(18, 2),(t1.cop - t2.cop)/ t2.cop * 100), '%') " +
                "        when t2.cop = 0 then '0' " +
                "        else '上期无数据' " +
                "        end cop_ratio, " +
                "  ht.amb_temp, " +
                "  ht.humidity " +
                "from " +
                "    ( " +
                "        select " +
                "            cur_date, " +
                "            elect, " +
                "            cl, " +
                "            cop, " +
                "            project_id, " +
                "            convert(datetime, ");
        concatMomSql(params, sql);
        sql.append("        from " +
                "            ${tableName} " +
                "        where " +
                "            cur_date >= #{startDate} " +
                "          and cur_date <= #{endDate} " +
                "          and project_id = #{projectId} " +
                "    ) t1 " +
                "        left join " +
                "    ( " +
                "        select " +
                "            cur_date, " +
                "            elect, " +
                "            cl, " +
                "            cop, " +
                "            project_id, " +
                "            convert(datetime, ");
        concatMomSql(params, sql);
        sql.append("        from " +
                "            ${tableName} " +
                "        where " +
                "            cur_date >= #{lastStartDate} " +
                "          and cur_date <= #{lastEndDate} " +
                "          and project_id = #{projectId} " +
                "    ) t2 " +
                "    on " +
                "        t1.change_cur_date = dateadd(year, 1, t2.change_cur_date) " +
                " left join hour_temperature ht  " +
                " on " +
                "   ht.cur_date = t1.change_cur_date " +
                " left join ( " +
                "   select " +
                "    id, " +
                "    project_name " +
                "   from " +
                "    project_info " +
                "   where " +
                "    id = #{projectId}) pi2  " +
                " on " +
                "  pi2.id = t1.project_id " +
                "order by t1.cur_date ");
        return sql.toString();
    }
}
