package com.mh.user.service;

import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONObject;
import com.mh.user.dto.ScreenRequestParamDTO;

/**
 * @author LJF
 * @version 1.0
 * @project mh_esi
 * @description 大屏服务类
 * @date 2024-09-24 14:02:44
 */
public interface ScreenService {

    /**
     * 获取项目概况以及当月项目数据
     * @param screenRequestParamDTO
     * @return
     */
    JSONArray energyData(ScreenRequestParamDTO screenRequestParamDTO);

    /**
     * 项目坐标以及是否有故障
     * @return
     */
    JSONArray projectData();

    /**
     * 当日节能量概况
     * @param screenRequestParamDTO
     * @return
     */
    JSONArray savingEnergy(ScreenRequestParamDTO screenRequestParamDTO);

    /**
     * 获取节能量同比
     * @param screenRequestParamDTO
     * @return
     */
    JSONArray savingYoyEnergyData(ScreenRequestParamDTO screenRequestParamDTO);

    /**
     * 故障详情
     * @return
     */
    JSONArray faultList();
}
