package com.mh.user.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.mh.common.page.MybatisPageHelper;
import com.mh.common.page.PageRequest;
import com.mh.common.page.PageResult;
import com.mh.common.utils.StringUtils;
import com.mh.user.entity.DeviceParamsEntity;
import com.mh.user.entity.GatewayManageEntity;
import com.mh.user.mapper.DeviceParamsMapper;
import com.mh.user.service.DeviceParamsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author LJF
 * @version 1.0
 * @project mh_esi
 * @description 设备采集服务类实现类
 * @date 2024-08-23 09:34:07
 */
@Service
public class DeviceParamsServiceImpl implements DeviceParamsService {

    @Autowired
    private DeviceParamsMapper deviceParamsMapper;

    @Override
    public PageResult queryByPage(PageRequest pageRequest) {
        String mtType = StringUtils.getColumnFilterValue(pageRequest, "mtType");
        // 设置分页参数
        int pageNum = pageRequest.getPageNum();
        int pageSize = pageRequest.getPageSize();
        if (pageNum != 0) {
            PageHelper.startPage(pageNum, pageSize);
        }
        QueryWrapper<DeviceParamsEntity> queryWrapper = new QueryWrapper<DeviceParamsEntity>();
        if (!StringUtils.isBlank(mtType)) {
            queryWrapper.eq("mt_type", mtType);
        }
        List<DeviceParamsEntity> manageEntities = deviceParamsMapper.selectList(queryWrapper.orderByDesc("id"));
        return MybatisPageHelper.getPageResult(pageRequest, new PageInfo<>(manageEntities));
    }

    @Override
    public void update(DeviceParamsEntity entity) {
        deviceParamsMapper.updateById(entity);
    }

    @Override
    public DeviceParamsEntity findById(Long id) {
        return deviceParamsMapper.selectById(id);
    }

    @Override
    public void save(DeviceParamsEntity entity) {
        deviceParamsMapper.insert(entity);
    }

    @Override
    public void delete(String id) {
        deviceParamsMapper.deleteById(id);
    }
}
