package com.mh.user.vo;

import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;

/**
 * @author LJF
 * @version 1.0
 * @project mh_esi
 * @description 对前端展示的--主机列表
 * @date 2024-08-28 11:21:19
 */
@Setter
@Getter
public class HostListVO implements Serializable {

    private static final long serialVersionUID = 1L;

    private String runningStatus;
    /**
     * 出水温度设定值
     */
    private String enteringTempSet;

    /**
     * 蒸发器侧进水温度
     */
    private String evapLeavingChWTemp;

    /**
     * 蒸发器侧出水温度
     */
    private String evapEnteringChWTemp;

    /**
     * 蒸发器侧趋近温度
     */
    private String evapApproach;

    /**
     * 冷凝器侧进水温度
     */
    private String condLeavingChWTemp;

    /**
     * 冷凝器侧出水温度
     */
    private String condEnteringChWTemp;

    /**
     * 冷凝器侧趋近温度
     */
    private String condApproach;

    /**
     * 额定制冷量
     */
    private String ratedRef;

    /**
     * 额定功率
     */
    private String ratedPower;

    /**
     * 额定COP
     */
    private String ratedCop;

    /**
     * 实时制冷量
     */
    private String realTimeChillerAmps;

    /**
     * 实时功率
     */
    private String realTimePower;

    /**
     * 实时COP
     */
    private String realTimeCop;

    /**
     * 实时告警
     */
    private String realTimeWarning;

    /**
     * 实时故障
     */
    private String realTimeFault;

    public void reset() {
        this.runningStatus = null;
        this.enteringTempSet = null;
        this.evapLeavingChWTemp = null;
        this.evapEnteringChWTemp = null;
        this.evapApproach = null;
        this.condLeavingChWTemp = null;
        this.condEnteringChWTemp = null;
        this.condApproach = null;
        this.ratedRef = null;
        this.ratedPower = null;
        this.ratedCop = null;
        this.realTimeChillerAmps = null;
        this.realTimePower = null;
        this.realTimeCop = null;
        this.realTimeWarning = null;
        this.realTimeFault = null;
    }

    @Override
    public String toString() {
        return "HostListVO{" +
                "enteringTempSet='" + enteringTempSet + '\'' +
                ", evapLeavingChWTemp='" + evapLeavingChWTemp + '\'' +
                ", evapEnteringChWTemp='" + evapEnteringChWTemp + '\'' +
                ", evapApproach='" + evapApproach + '\'' +
                ", condLeavingChWTemp='" + condLeavingChWTemp + '\'' +
                ", condEnteringChWTemp='" + condEnteringChWTemp + '\'' +
                ", condApproach='" + condApproach + '\'' +
                ", ratedRef='" + ratedRef + '\'' +
                ", ratedPower='" + ratedPower + '\'' +
                ", ratedCop='" + ratedCop + '\'' +
                ", realTimeChillerAmps='" + realTimeChillerAmps + '\'' +
                ", realTimePower='" + realTimePower + '\'' +
                ", realTimeCop='" + realTimeCop + '\'' +
                ", realTimeWarning='" + realTimeWarning + '\'' +
                ", realTimeFault='" + realTimeFault + '\'' +
                '}';
    }
}
