package com.mh.user;

import com.github.pagehelper.PageInfo;
import com.mh.common.page.PageResult;
import com.mh.user.dto.EnergyMomYoyDataDTO;
import com.mh.user.mapper.chillers.DealDataMapper;
import com.mh.user.model.EnergyModel;
import com.mh.user.service.EnergyDataService;
import com.mh.user.service.chillers.DealDataService;
import com.mh.user.utils.ExchangeStringUtil;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * @author ljf
 * @title ：
 * @description ：
 * @updateTime 2020-07-28
 * @throws ：
 */
@Slf4j
public class DealDataTest extends UserServiceApplicationTests {

    @Autowired
    private DealDataService dealDataService;

    @Test
    public void dealChillersData() {
        try {
            for (int i = 1; i < 60; i++) {
                String curDate = "2024-10-10 00:" + ExchangeStringUtil.addZeroForNum(String.valueOf(i), 2) + ":00";

                System.out.println(curDate);
            List<String> list=dealDataService.queryProjectId("1");
            if (!list.isEmpty()){
                for(String projectId:list){
                    dealDataService.proDataResult(curDate,projectId); //1珠江酒店，2广合，3广大
                }
            }
            log.info("---------能效监测定时汇总，每一分钟！{}", curDate);
            }

        } catch (Exception e) {
            log.error("能效监测定时汇总异常", e);
        }
    }

    @Autowired
    private EnergyDataService energyDataService;

    @Test
    public void queryEnergyData(){
        EnergyModel energyModel = new EnergyModel();
        energyModel.setPage(1);
        energyModel.setLimit(10);
        energyModel.setStartDate("2023");
        energyModel.setEndDate("2024");
        energyModel.setProjectId("3");
        energyModel.setQueryType(0);
        energyModel.setType(5);
        PageResult pageResult = energyDataService.queryMomEnergyData(energyModel);
        System.out.println(pageResult);

    }
}
